/* Big Table Sorter v3.0 (+ JS Data Filter) 
@require http://ir2.ru/tabtools.js 31.11.2010 
@require http://ir2.ru/tabsort.css 31.11.2010 
@require http://ir2.ru/classes.css 
[@require http://ir2.ru/arrows.css] 
[@require http://ir2.ru/kino/img/] 
*/

/* : 

( : http://ir2.ru/javascript_bd.aspx -  )

I 

1)  ( - HEAD)       http://ir2.ru/tabsort.css, http://ir2.ru/classes.css, http://ir2.ru/tab_vis.js;
2)   ( TABLE)  class='sortable' 
 (  : class='big fix sortable');
3)    (     ) 
      TH (  TD);
4)     (str   -   )  : num|ip|datru|daten|formula, 
         axis: <th axis="num">;
5)      :
    Shift - Number,
    Ctrl - Date (RU),
    Ctrl+Alt - Date (EN)
6)        title " ...", 
      "" use_title = true;
7)        ( cookie), 
     ""   use_cookie = true;
8)      (   ) 
        Ctrl+Alt+Shift;
9)    ,    
     THEAD (  <thead> </thead>);
10)  use_appendChild = false //  ;
11) use_zebra = true   ;
12)    ( )     test_sort.js;
13)       
 (  )    class='sortable'  
   prepTabs(t)   -   HTML- 
 (  ). !! 

II 

1)             
  (axis)   ""  use_inputs = true;
2)            
   ""  use_inputs = true, inputs_force = true;
3)        Escape (  ,  );
4)      ( )     ;
5)     __       
 (    ) ^ ("").
6)   (is_dict = true)       
    .     ""  axis='idx',
    "" axis='fulltxt'.

III   

1)         paginate: true;
2)     page_size (  20) 
    "  ";
3)    ,   ; paginate: false   
       

VI 

1)       ,  
      colgroup    col 
    (<colgroup><col><col><col>...</colgroup>).
2)     CSS table-layoute:fixed    . 
         ,     
   .

Task:

1) ,         (  ).
 2)      (    ).
3)    . , first_sort_line   , 
 .. tbody    ;      (tbody    ).
4)    make_whole_arr (  jSorter).
5)  " "  (.., ).
 6)  .

*/

/*  */
window.def = {
 /*   title: */
 use_title: true, /* added by Clusta */
 /* -   */
 use_cookie: true,
 /*     : */
 show_log: false,
 /* "" : */
 use_zebra: true,
 /*      (): */
 use_inputs: true,
 /*    axis (  String): */
 inputs_force: true,
 /*   : */
 use_arrows: true,
/*  */
 paginate: true,
/*      : */
 sort_all_rows: true,
/*       : */
 auto_detect: true,
/*   (  ): */
 show_def: true,
/*     : */
 pick: false,
/*   : */
 is_dict: false //,
// make_whole_arr: false
}

 /*    ,     */
if (!def.use_arrows) document.write('<link rel="stylesheet" href="arrows.css" type="text/css">\n')
 /*     */
document.write('<style type="text/css">.sortable tbody {display:none;}</style>\n')

/*   */

addLoadEvent(prepTabs)

function docKey(e) {
 e = e || window.event
 prevent(e)
 if (27 == e.keyCode) {
  if (global.result) changeClass(global.result, invis_class, 2)
  if (global.msg) changeClass(global.msg, invis_class, 2)
  return
 }
 if (!def.paginate || !e.ctrlKey || (37 != e.keyCode && 39 != e.keyCode)) return
 var dir = (39 == e.keyCode) ? 1 : -1
 var maxi = (e.altKey) ? true : false
 move(dir, maxi)
}

/******************** Big Table Sorter *******************/

function prepTabs(t) {
 document.onkeyup = docKey //  (esc), paginate (ctrl + larr)

 /*  HTML   body */
 /*    */
 var def_visual = initBoxes("def", def.show_def)
 if (def_visual) {  /*   */
  document.body.insertBefore(def_visual, document.body.firstChild)
 }
 if (def.show_log && global.msg) {  /*  */
  global.msg = document.body.appendChild(global.msg)
  if (!window.d0) d0 = new Date()
  else { 
   addLog("DOM: ")
  }
  addLog("... ", "", true)
 }

 /*     debugger.ru,   */
 if (!def.use_arrows) document.body.appendChild(global.img_loader)
  /*     */
 global.result = document.body.appendChild(global.result)

 /*  HTML   body  */

 /*     onclick */
 var uri = location.pathname, table, thead, task,
  list = (t && t.className) ? [t] : document.getElementsByTagName("TABLE");
 for (var k=0; k < list.length; k++) { 
  table = list[k];
  if (!_hasClass(table.className, sort_table_class)) continue; 
  /*  []  */
  var first_sort_line = 0, rh = table.rows[first_sort_line];
  thead = rh.parentNode;
  while (rh.parentNode.tagName == "THEAD"){
   first_sort_line++;
   rh = table.rows[first_sort_line];
  }
  var tbody = findChild(table, "TBODY")
  if (!first_sort_line) { /* rh.parentNode -  thead! */
   /*    ,    #1 */
   first_sort_line = 1; 
   /* thead     */
   thead = document.createElement("THEAD")
   table.insertBefore(thead, tbody)
   thead.appendChild(rh)
  }

  table.tid = k;
  table.idx = null;
  table.first_sort_line = first_sort_line;
  table.thead = thead;
  thead.onclick = clickTab;
  changeClass(thead, "pointer", 2);
  table.rarr = []; /* rarr: 'row array' */
  table.vrarr = null; /* : visual rarr */
  /*  paginate */
  table.first_line = 0;
  global.last_table = table;
  if (window.colNames) {
   window.col_names = colNames(table)
   if (window.col_names) {
    window.cols = initBoxes("col_names", true)
    document.body.insertBefore(cols, document.body.firstChild)
   }
  }

  cellsInHeader(table)
  addLog("Table_arrows: ", k)
  if (def.use_title) thead.title = ""

  var navig = table.parentNode.insertBefore(global.navig.cloneNode(true), table)

  if (def.is_dict && table.idx_name && table.fulltxt_name) {
   var seek_form = navig.parentNode.insertBefore(global.seek_form.cloneNode(true), navig)
   table.seekval = findChild(seek_form, "input", "seekval")
   findChild(seek_form, "span", "mainfield").innerHTML = table.idx_name
   findChild(seek_form, "span", "fulltxtfield").innerHTML = table.fulltxt_name
  }

  table.pagenum = findChild(navig, "span", "pagenum")
  table.pageall = findChild(navig, "span", "pageall")
  table.page_size = findChild(navig, "input", "page_size", true)
  table.page_size.value = page_size

  if (!def.paginate) {
   changeClass(navig, invis_class, 2)
  }

  /*   end */

  task = null
  if (def.use_cookie) { 
  /*    */
   table.cookid = new Array(uri + "_tab" + k, "");
   task = getCookie(table.cookid[0])
   if (task) {
    addLog("... ", "", true)
    var taskarr, cellid, rowid, coo, obj
    task=task.split(",")
    for (var j=0; j<task.length; j++) {
     if (!task[j]) continue;
     taskarr=task[j].split(":")
     coo = taskarr[0].split(dec)
     rowid = Math.abs(parseInt(coo[0]))
     if (!coo[1]) continue;
     cellid = Math.abs(parseInt(coo[1]))
     obj = table.rows[rowid].cells[cellid]
     if (!obj) continue
     if (undefined === obj.cellIndex)
      alert(",   .   ( 'ok')!")
     sortTab(obj, taskarr[1], true)
     /* page()    bull    -    */
    }
    addLog(" : ")
   }
  /*     */
  }
  if (!task) makeSortArr(table)
  if (!def.paginate) {
   var lr = table.rarr.length
   page_size = (lr > page_size) ? lr : page_size
  }
  page()
 }
 addLog(" : ")
}

function move(d, m) {
 if (def.show_log) d0 = new Date()
 var table = global.last_table, 
  rarr = table.vrarr || table.rarr,
  lr = rarr.length, first_arr_line = 0
 if (!lr) {
  rarr = table.rows
  lr = rarr.length
  first_arr_line = table.first_sort_line
  if (!lr) addLog("move(): !lr", "", true)
 }
 var fl = table.first_line, ll, nfl, nll
 if (d == 0) {
  table.first_line = first_arr_line
  return page()
 }
 else if (d == -1) {
  nfl = (m || (fl - page_size < first_arr_line)) 
  ? first_arr_line : fl - page_size
 }
 else if (d == 1) {
  nfl = (m) ? lr - page_size : (fl + page_size < lr)
   ? fl + page_size : fl
 }
// alert("//lr:" + lr + "//fl:" + fl + "//nfl:" + nfl)
 if (nfl != fl) {
  nfl = (nfl < 0) ? 0 : nfl
  if (nfl != table.first_line) {
   table.first_line = nfl
   page()
  }
 }
}

function page() {
 var table = global.last_table, rarr = table.vrarr || table.rarr
 if (!rarr || !rarr.length) {
  alert(" . \n    .")
  return false
 }
 var old_tbody = findChild(table, "TBODY") || table.appendChild(document.createElement("TBODY"))
 var tbody = document.createElement("TBODY")
 var row, cSwitch, i = table.first_line, lr = rarr.length,
  l = (i + page_size > lr) ? lr : i + page_size
 table.pagenum.innerHTML = Math.ceil(l / page_size) + " "
 table.pageall.innerHTML = Math.ceil(lr / page_size) + " "
// alert("i:" + i + "//l:" + l + "//lr:" + lr)
 for(i; i<l; i++){
  if (!rarr[i]) addLog("page: !i ", "", true)
  row = rarr[i].val
  if (def.use_zebra) {
   cSwitch = (0 === i%2) ? ["odd", "even"] : ["even", "odd"]
   changeClass(row, cSwitch, 4)
  }
  tbody.appendChild(row.cloneNode(true))
 }
 table.replaceChild(tbody, old_tbody)
 if (def.pick && window.pickHref) {tbody.onclick = pickHref;}
 addLog("page: ")
 return false
}

function clickTab(e) {
 if (def.show_log) d0 = new Date()
 e = e || window.event;
 prevent(e);
 var data_type = false;
 var obj = e.target || e.srcElement;
// obj.onselectstart = function() {return false};
 if (!e.ctrlKey && e.shiftKey && !e.altKey) {data_type = "num"; deselect()}
 if (e.ctrlKey && !e.shiftKey && e.altKey) data_type = "daten";
 if (e.ctrlKey && !e.shiftKey && !e.altKey) data_type = "datru";
 
 /*     HTML */
 if ("INPUT" == obj.tagName) return;
 if ("TH" != obj.tagName && "TD" != obj.tagName) {
  /*   */
  obj = findParent(obj, "TH") || findParent(obj, "TD"); 
 }
 if (!obj || obj.axis == 'unsort') return

 var table = findParent(obj, "TABLE", sort_table_class);
 if (!table) return; 
 global.last_table = table;
 if (e.ctrlKey && e.shiftKey && e.altKey) {
  clearHist(table);
  return;
 }
 sortTab(obj, data_type) /* : ,  ,   */
}

function sortTab(obj, user_data_type, dont_draw) {
 var ci = obj.cellIndex, table = global.last_table; /*  */
 var row = findParent(obj, "TR"), ri = row.rowIndex; /*  */
 var i = obj.realIndex, cell = ri + "." + ci /*   */;
 var rarr = table.vrarr || table.rarr, sortcell = "sortcell_" + i,
  verse = /d\_\d+\_d/.test(obj.className)
 global.verse = verse

 var data_type = user_data_type || getDataType(obj),
  sorttype = (data_type_patt.test(data_type)) ? 0 : 1,
  sortcell = "sortcell_" + i
 /*    ()      */
 if (!rarr[0] || undefined == rarr[0][sortcell] 
  || (user_data_type && data_type != user_data_type)) {
  makeSortArr(table, i, data_type)
 }
 
 var cmpRow = "(a == b) ? 0 : (a " + (verse ? "<" : ">") + " b) ? 1 : -1",
  cmpNum = (verse) ? "b - a" : "a - b",
  cmp = (sorttype) ? cmpRow : cmpNum
 cmp = new Function("a, b", "a = a['" + sortcell + "']; b = b['" + sortcell + "']; return(" + cmp + ");")

 rarr = rarr.sort(cmp)

 addLog("Table_sort (" + data_type + "): ", table.tid)
 updArrow(obj, table, cell, verse)

 var addBull = function () {
  var a = findChild(obj, "div", "arrows", true)
  if (!a) return
  changeClass(global.bull, "bup", (verse) ? 2 : 3)
  a.appendChild(global.bull)
 }

 if (!dont_draw) {
  global.last_table = table
  page()
 }
 if (def.use_arrows) addBull()
}

function updArrow(obj, table, cell, verse) {
 var i = obj.realIndex;
 var data_type = getDataType(obj)
 changeClass(obj, "sorted", 2)
 var title = "  ", cookid1 = ","
 var dir = "d"
 if (verse) {
  cookid1 += "-"
  title = "  "
  dir = "u"
 }
 if (def.use_title) obj.title = title
 /* new arrows (div) */
 var c = obj.className, re = new RegExp(/[cdu]\_\d+\_[cdu]/),
  new_class = dir + "_" + arrow_color + "_" + dir
 if (arrow_color < 8) arrow_color++
 if (re.test(c)) obj.className = c.replace(re, new_class)
 else changeClass(obj, new_class, 2)
 /* new arrows (div) end*/
 if (def.use_cookie && table.cookid) {
  table.cookid[1] += cookid1 + cell + ":" + data_type
  var tocut=new RegExp(cell+"\\:"+data_type+"\\,(\\-?"+cell+"\\:\\w+\\,)+"+cell+"\\:"+data_type)
  table.cookid[1] = table.cookid[1].replace(tocut, cell+":"+data_type)
  setCookie(table.cookid[0], table.cookid[1], "", 0)
 }
  addLog("Upd_arrow: ", i)
}

function makeSortArr(table, i, data_type) {
 if (isNaN(i)) {
  i = 0
  data_type = getDataType(table.rows[0].cells[i])
 }
 data_type = data_type || "str"
 var n = -1

 function idx_calc(row) {
  var cell = row.cells[parseInt(table.idx)],
   val = cell && cell.innerHTML, i, idx = ''
  if (!val) return null
  val = stripTags(val).toLowerCase()
  for (i = 0; i < 5; i++) {
   idx += (val[i]) ? global.bukva[val[i]] : '00'
//   if (global.bukva[val[i]]==undefined) addLog("//"+val[i]+"//", "", true)
  }
  idx += '00'
  return [val, idx]
 }

 var id, bukvy = " '.-0123456789abcdefghijklmnopqrstuvwxyz"
 global.bukva = {}
 bi = 0
 for (var b = 0; b < bukvy.length; b ++) {
  id = bi.toString()
  if (id.length < 2) id = "0" + id
  global.bukva[bukvy[b]] = id
  bi ++
 }

 var ru = new RegExp("[--]+", "ig")
 var month = {
  ru: {"":"01", "":"02", "":"03", "":"04", "":"05", "":"05", "":"06", "":"07", "":"08", "":"09", "":"10", "":"11", "":"12"},
  func: function (str) {
   var m = str.substring(0, 3)
   m = month.ru[m] ? month.ru[m] : "00"
   return(m)
  }
 }

 calcSortData = function (data_type, sortcell_value) {
  var sortcell_calc_value, formula
  switch (data_type) {
   case "num":
    sortcell_calc_value = parseFloat(sortcell_value.replace(undigit, ""));
    sortcell_calc_value = (isNaN(sortcell_calc_value)) ? Infinity : sortcell_calc_value; 
    break
   case "formula":
    formula = new RegExp("\\((.*?)\\)").exec(sortcell_value);
    sortcell_calc_value = parseFloat((formula && formula[1]) ? eval(formula[1]) : sortcell_value.replace(undigit, ""));
    sortcell_calc_value = (isNaN(sortcell_calc_value)) ? Infinity : sortcell_calc_value; 
    break
   case "ip":
    sortcell_calc_value = sortcell_value.replace(/\b(\d)\b/g, "00$1");
    sortcell_calc_value = sortcell_calc_value.replace(/\b(\d\d)\b/g, "0$1");
    sortcell_calc_value = parseFloat(sortcell_calc_value.replace(/\./g, ""));
    sortcell_calc_value = (isNaN(sortcell_calc_value)) ? Infinity : sortcell_calc_value; 
    break
   case "datru":
    if (sortcell_value.search(ru) != -1) sortcell_calc_value = sortcell_value.replace(ru, month.func)
    else sortcell_calc_value = sortcell_value
    if (/\:/.test(sortcell_calc_value)) sortcell_calc_value = sortcell_calc_value.replace(/^(.*?)(\d+)\:(\d+)/, "$3 $2 $1")
    else sortcell_calc_value = "0000 " + sortcell_calc_value
    sortcell_calc_value = sortcell_calc_value.replace(/\b(\d)\b/g, "0$1")
    sortcell_calc_value = sortcell_calc_value.split(/\D+/).reverse().join(""); 
    sortcell_calc_value = (isNaN(sortcell_calc_value)) ? Infinity : sortcell_calc_value; 
    break
   case "daten":
    sortcell_calc_value = Date.parse(sortcell_value);
    sortcell_calc_value = (isNaN(sortcell_calc_value)) ? Infinity : sortcell_calc_value; 
    break
   default:
    sortcell_calc_value = sortcell_value.toString()
    break
  }
  return sortcell_calc_value
 }

 /*          */
// addLog("fl_" + table.first_sort_line + ". ", "", true)
 var tmp, row, newval, sortcell = "sortcell_" + i, source = "source_" + i, 
  sortcell_value, sortcell_calc_value, newrarr, first_sort_line = table.first_sort_line, 
  first, last, rarr = def.sort_all_rows ? table.rarr : table.vrarr || table.rarr,
  cell_idx, idx, d_idx = 1, idx_old = null, arr_name = (rarr == table.vrarr) ? "vrarr" : "rarr"

 if (rarr && rarr.length) {
  first = 0
  last = rarr.length
  newrarr = false
 }
 else { /*     */
  rarr = []
  table.sarr = {} //(for search)
  table.farr = [] //(for filter)
  first = 0
  var shadow_tb = findChild(table, "tbody")
  shadow_tb = document.createElement("table").appendChild(shadow_tb, true)
  /*   tbody  ,     - : */
  changeClass(table, [sort_table_vis_class, sort_table_class], 4)
  last = shadow_tb.rows.length
  newrarr = true
 }
 for (var j = first; j < last; j ++) {
  n++
  newval = 0;
  row = (newrarr) ? shadow_tb.rows[j] : rarr[j].val
  sortcell_value = row && row.cells[i];
  if (newrarr) {
   cell_idx = idx_calc(row)
   if (cell_idx) {
    idx = parseInt(cell_idx[1])
    if (cell_idx[0] != idx_old) {
     table.sarr[cell_idx[0]] = shadow_tb.rows[j]
     d_idx = 1
    }
    else {idx += d_idx++}
    table.farr[idx] = shadow_tb.rows[j]
//    shadow_tb.rows[j].cells[1].innerHTML += "<br>"+idx
    idx_old = cell_idx[0]
   }
  }
  /*        */
  try {sortcell_value = sortcell_value && sortcell_value.innerHTML || "";}
  catch(e) { 
  //alert(",      \n   . : \n"
  // + e.message + j + "//" + i); return;
   sortcell_value = ""
  }
  sortcell_value = stripTags(sortcell_value).toLowerCase();
  sortcell_calc_value = calcSortData(data_type, sortcell_value)
///*:*/  if (row.cells[i]) row.cells[i].innerHTML += "<br>" + sortcell_calc_value + "<br>: " + typeof sortcell_calc_value
  /*      (IE):   - cloneNode? */
  if (newrarr) {
   table[arr_name][n] = {val:row}
   table[arr_name][n][sortcell] = sortcell_calc_value
   table[arr_name][n][source] = sortcell_value.toString()
  }
  else {
   table[arr_name][j][sortcell] = sortcell_calc_value
   table[arr_name][j][source] = sortcell_value.toString()
  }
 }
 addLog("  (" + sortcell + "): ")
}

function getDataType(cell) {
 var data_type = cell && cell.axis.match(data_type_patt)
 return (data_type && data_type[1]) || "str"
}

function arrows() {
////   inputs_HTML = "<div class='arrows inp'><div class='up'></div><div class='down'></div></div>" + inputs_HTML
////   input_HTML = "<div class='arrows inp'><div class='up'></div><div class='down'></div></div>" + input_HTML
    /*    SortTable.1.5.1.zip
    (http://debugger.ru/blog/bystraja_sortirovka_tablic,
    Ilya Lebedev, ilya@lebedev.net): */
//  changeClass(arrows_el, '', 2)
}
function cellsInHeader (table) {
 var row, cells, cell, colspan, rowspan, ci, dCell, dRow = [], axis,
  first_sort_line = table.first_sort_line, i = 0, val, old_h
 for (i; i <= first_sort_line; i++) {
  dRow[i] = []
 }
 for (i = 0; i < first_sort_line; i++) {
  row = table.rows[i]
  cells = row.cells
  changeClass(row, arrow_unsort, 2)
  dCell = 0
  for (j = 0; j < cells.length; j ++) {
   cell = cells[j]
   colspan = Number(cell.colSpan) - 1
   rowspan = Number(cell.rowSpan) - 1
   ci = j + dCell
   while (dRow[i][ci]) {
     dCell += dRow[i][ci]
     ci++
   }
   ci = j + dCell
   dCell += colspan
   cell.realIndex = ci 
   if (rowspan) {
    for (var r = i + 1; r <= i + rowspan; r++) {
     dRow[r][ci] = colspan + 1
    }
   }
   axis = cell.axis
   
   if (cell.axis == 'idx') {table.idx = ci; table.idx_name = cell.innerHTML}
   if (cell.axis == 'fulltxt') {table.fulltxt = ci; table.fulltxt_name = cell.innerHTML; table.fulltxt_cell = cell;}
   
   if (axis == 'unsort') {
    cell.style.cursor = 'default'
    cell.title = ' '
    continue
   }
   else if (!axis && def.auto_detect) {
    val = table.rows[first_sort_line].cells[ci]
    val = stripTags(val && val.innerHTML)
    if (!isNaN(Number(val))) {
     axis = "num"
     cell.axis = axis
    }
    else if (val.match(/^\d+\.\d+\.\d+\.\d+$/)) {
     axis = "ip"
     cell.axis = axis
    }
   }
   if (def.use_inputs) { /*    */
    if (axis || def.inputs_force) {
     cell.appendChild((("num" == axis || "formula" == axis) ? global.inputs_el : global.input_el).cloneNode(true))
    }
   }
   if (def.use_arrows) {
    old_h = cell.offsetHeight
    cell.insertBefore(global.arrows_el.cloneNode(true), cell.firstChild)
    cell.style.width = cell.offsetWidth + 11
    cell.style.height = old_h
   }
  }
 }
}

function addLog(txt, num, no_upd) {
 if (!def.show_log || !global.msg) return
 var d1 = new Date()
 if (!isNaN(num)) {
  if (txt.indexOf("_")>-1) txt = txt.replace(/\_/, num + "_")
  else txt += num.toString()
 }
 global.msg.innerHTML += txt + (!no_upd ? (d1 - d0) + " ms. " : "")
 if (!no_upd) d0 = d1
}

function clearHist(table) {
  table = table || global.last_table
  if (!table.cookid) return;
  setCookie(table.cookid[0], "", "", -1) /* 'delete cookie' */
  location.reload();
}

/******************** end Big Table Sorter *******************/

/******************** JS Data Filter *******************/

function setWidth(obj, c) {
 var w = c.offsetWidth, w3 = w - 30, wi = obj.offsetWidth
 w3 = (w3 > 200) ? 200 : w3
 if (wi < w3) {
  obj.style.width = w3
  c.width_isset = true
 }
// alert(w + "//w3: " + w3 + "//wi: " + wi + "//c.offsetWidth:" + c.offsetWidth)
}

function dataSeek() {
 var table = global.last_table, q = table.seekval.value.toLowerCase(),
  cid = table.fulltxt, source = "source_" + cid, result = global.result,
  tmp_rarr = [], rarr = table.rarr, vl = table.vrarr && table.vrarr.length
 if (vl) rarr = table.vrarr
 if (def.show_log) d0 = new Date();

 coo = getTopLeft(table.fulltxt_cell)
 result.style.top = coo.top - 10
 result.style.left = coo.left

 var pflag = false, l = rarr.length, m = 0, ok = false, counter = 0
 for (var i = 0; i < l; i++) { 
  if (!rarr[i]) continue
  row = rarr[i].val
  if (row.cells[cid]==undefined) return alert(i + "//" + row.innerHTML)
  val = rarr[i][source] || stripTags(row.cells[cid].innerHTML).toLowerCase()
  ok = val.indexOf(q) > -1
  if (ok) {
   counter++
   pflag = true
   tmp_rarr[m] = rarr[i]
   m++
  }
 }
 result.innerHTML = counter
 if (pflag) {
  table.vrarr = tmp_rarr
  changeClass(result, invis_class, 3)
  addLog("Seek_'" + q + "': ", source)
  table.first_line = 0
 }
 else {
  table.vrarr = null
  addLog("Seek_'" + q + "': ", source)
 }
 move(0)
}

function seek(clear) {
 var i, j, idx = "", tx, table = global.last_table, val = table.seekval.value.toLowerCase()
 table.vrarr = []
 if (!val || clear) {
  table.seekval.value = ''
  changeClass(global.result, invis_class, 2)
  table.vrarr = table.rarr
  return move(0)
 }
 if (val in table.sarr) {
  table.vrarr[0] = {}
  table.vrarr[0].val = table.sarr[val]
 }
 else {
  for (i = 0; i < 5; i++) {
   idx += (val[i]) ? global.bukva[val[i]] : '00'
  }
  idx += '00'
  idx = parseInt(idx)
  j = 0
  for (var id in table.farr) {
   if (j >= page_size) break
   if (id >= idx) {
    table.vrarr[j] = {}
    table.vrarr[j].val = table.farr[id]
    j ++
   }
  }
 }
 if (table.vrarr.length) move(0)
}

function dataFilter(obj, n) {
 var c = findParent(obj, "TH") || findParent(obj, "TD")
 if (!c.width_isset) setWidth(obj, c)
 if (" " == obj.value || "^" == obj.value) return
 if (def.show_log) d0 = new Date();
 var value = obj.value, q = value, q_int, qr, row, axis = obj.axis, 
  exclude = (0 == q.indexOf("^"));
 q = (exclude) ? q.substring(1) : q;
 var pflag = false, val, val_int, val_calc, data_type = getDataType(c), 
  counter=0, space = (0 == q.indexOf(" "));
 q = (space) ? q.substring(1) : q;
 var table = findParent(obj, "TABLE"), result = global.result,
  cid = c.realIndex, fields = c && c.getElementsByTagName("INPUT"),
  field1 = fields && fields[0], val1 = field1 && field1.value, val1_int = parseFloat(val1),
  field2 = fields && fields[1], val2 = field2 && field2.value, val2_int = parseFloat(val2),
  axis1 = field1 && field1.axis, axis2 = field2 && field2.axis, 
  source = "source_" + cid, sortcell = "sortcell_" + cid, coo = getTopLeft(c)
//  alert(c.cellIndex + "" + ri)
 global.last_table = table
 result.style.top = coo.top - 10
 result.style.left = coo.left
 if (!val1 && !val2) {
/*   ,     */
  if (axis1 || axis2) {
   changeClass(result, invis_class, 2)
   table.vrarr = null
   obj.axis = value
   addLog("UnFilter: ")
   move(0)
  }
  return
 }
 if (axis == value && !field2) return
 
 obj.axis = value
 q = q.toLocaleLowerCase()
 q_int = parseInt(q)

 var tmp_rarr = [], rarr, vl = table.vrarr && table.vrarr.length
 if (vl && (!axis || value.indexOf(axis) == 0)) {
/*            */
  rarr = table.vrarr
 }
 else { /*  table.vrarr     */
  rarr = table.rarr
  if (!rarr || !rarr.length) { /*    */
   makeSortArr(t, cid, data_type)
   rarr = table.rarr
  }
  clearInputs(fields)
  table.vrarr = null
  vl = 0
 }
 
 var l = rarr.length, m = 0, ok = false, x=0, classN
 for (var i = 0; i < l; i++) { 
  if (!rarr[i]) continue
  row = rarr[i].val
  classN = row.className
  if (!row.cells[cid]) {continue}
  val = rarr[i][source] || stripTags(row.cells[cid].innerHTML).toLowerCase()
  val_calc = rarr[i][sortcell] || calcSortData(data_type, val)
  val_int = !isNaN(val_calc) ? val_calc : Infinity
  switch (n) {
   case 1:
    ok = ((isNaN(q_int) || val_int>=q_int) && (isNaN(val2_int) || val_int<=val2_int))
   break
   case 2:
    ok = ((isNaN(q_int) || val_int<=q_int) && (isNaN(val1_int) || val_int>=val1_int))
   break
   default:
    ok = (space) ? (val.indexOf(q) > -1) : (val.indexOf(q) === 0)
    if (exclude) ok = !ok
   break
  }
  if (ok) {
   counter++
   pflag = true
   if (val_calc) tmp_rarr[m] = rarr[i]
   else {addLog(arguments.callee + ": !val_calc !", "", true)}
   m++
  }
 }
 result.innerHTML = counter

 if (pflag) {
  table.vrarr = tmp_rarr
  changeClass(result, invis_class, 3)
  addLog("Seek_'" + value + "': ", source)
  table.first_line = 0
 }
 else {
  table.vrarr = null
  addLog("Seek_'" + value + "': ", source)
 }
 move(0)
}

function clearInputs(fields) {
 fields = fields || [{},{}]
 var el, val, list = findParent(fields[0], "thead")
 list = list && list.getElementsByTagName("INPUT")
 if (!list) return
 for (var i in list) {
  el = list[i]; val = el.value
  if (!el.tagName || el == (fields && fields[0]) || el == (fields && fields[1])) continue
  if (val != "") {
   el.value = ""
   el.axis = ""
  }
 }
}

/******************** end JS Data Filter *******************/

